################
## LISTING 32.1
################
class Stack(object):
    def __init__( self):
        self.stack = []                   #A
    def get_stack_elements(self):
        return self.stack.copy()          #B
    def add_one(self , item):
        self.stack.append(item)           #C
    def add_many(self , item, n):
        for i in range(n):                #D
            self.stack.append(item)       #D
    def remove_one(self):
        self.stack.pop()                  #E
    def remove_many(self , n):
        for i in range(n):                #F
            self.stack.pop()              #F
    def size(self):
        return len(self.stack)            #G
    def prettyprint(self):
        for thing in self.stack[::-1]:    #H
            print('|_',thing, '_|')       #H
#A A list data attribute defines the stack.
#B Method to return a copy of the data attribute representing the stack
#C Method to add one item to the stack; adds it to the end of the list
#D Method to add n of the same item to the stack
#E Method to remove one item from stack
#F Method to remove n items from the stack
#G Method to tell you the number of items in the stack
#H Method to print a stack with each item on a line, with newer items on top 





################
## LISTING 32.2
################
pancakes = Stack()                        #A
pancakes.add_one("blueberry")             #B
pancakes.add_many("chocolate", 4)         #C
print(pancakes.size())                    #D
pancakes.remove_one()                     #E
print(pancakes.size())                    #F
pancakes.prettyprint()                    #G
#A Creates a stack and binds the Stack object to a variable named pancakes
#B Adds one blueberry pancake
#C Adds four chocolate pancakes
#D Prints 5 
#E Removes the string that was added last, a chocolate pancake
#F Prints 4
#G Prints each pancake flavor on a line: three chocolate ones on top, and one blueberry at the bottom





################
## LISTING 32.3
################
circles  = Stack()                        #A
one_circle = Circle()                     #B
one_circle.change_radius(2)               #B
circles.add_one(one_circle)               #B

for i in range(5):                        #C
    one_circle = Circle()                 #D
    one_circle.change_radius(1)           #D
    circles.add_one(one_circle)           #D

print(circles.size())                     #E
circles.prettyprint()                     #F
#A Creates a stack and binds the Stack object to a variable named circles
#B Creates a new circle object, sets its radius to 2, and adds the circle to the stack
#C A loop to add five new circle objects
#D Creates a new circle object each time through the loop, sets radius to 1, and adds it to the stack
#E Prints 6
#F Prints Python information related to each circle object (its type and location in memory)


################
## LISTING 32.4
################
circles  = Stack()                        #A
one_circle = Circle()                     #A
one_circle.change_radius(2)               #A
circles.add_one(one_circle)               #A

one_circle = Circle()                     #B
one_circle.change_radius(1)               #B
circles.add_many(one_circle, 5)           #C

print(circles.size())                     #D
circles.prettyprint()                     #E
#A Same operations as listing 32.3
#B Creates a new circle object, sets its radius to 1
#C Adds the same circle object five times using a method defined in Stack class
#D Prints 6, the total number of circles added at this point
#E Prints Python information related to each circle object (its type and location in memory)
