################
## LISTING 38.1
################
import tkinter 
window = tkinter.Tk()
window.geometry("800x800")
window.title("Tag!")
canvas = tkinter.Canvas(window)           #A
canvas.pack(expand=1, fill='both')        #B
#A Canvas widget that will contain the player shapes
#B Adding the canvas so that it fills entire window and scales if the window is resized



################
## LISTING 38.2
################
import random
class Player(object):
    def __init__(self, canvas, color):            #A
        self.color = color                        #B
        size = random.randint(1,100)              #C
        x1 = random.randint(100,700)              #D
        y1 = random.randint(100,700)              #E
        x2 = x1+size                              #F
        y2 = y1+size                              #G
        self.coords = [x1, y1, x2, y2]            #H
        self.piece = canvas.create_rectangle(self.coords)        #I
        canvas.itemconfig(self.piece, fill=color)                #J
#A init method to create an object that takes in the canvas on which to add the shape, and the shapes color
#B Sets the color of the object as a data attribute
#C Chooses a random number between 1 and 100 for the size of the player piece
#D The coordinate of the top-left corner of the object, also selected randomly between the range specified
#E The coordinate at the bottom right of the object
#F Sets the coordinates of the object as a data attribute, with type list
#G The player piece is a rectangle, placed at the position given by the coordinates.
#H Sets the color of the player piece, referencing it by its variable name, self.piece from the preceding line



################
## LISTING 38.3
################
def handle_key(event):                    #A
    if event.char == 'w' :                #B
        player1.move("u")                 #C
    if event.char == 's' :
        player1.move("d")
    if event.char == 'a' :
        player1.move("l")
    if event.char == 'd' :
        player1.move("r")
    if event.char == 'i' :                 #D
        player2.move("u")                  #E
    if event.char == 'k' :
        player2.move("d")
    if event.char == 'j' :
        player2.move("l")
    if event.char == 'l' :
        player2.move("r")
          
window = tkinter.Tk()
window.geometry("800x800")
window.title("Tag!")
canvas = tkinter.Canvas(window)
canvas.pack(expand=1, fill='both')

player1 = Player(canvas, "yellow")
player2 = Player(canvas, "blue")
canvas.bind_all('<Key>', handle_key)           #F
#A Event handler function
#B Checks whether the keypress from the event is a W
#C move is a method that youll define in the player class, so call that method to move the shape up
#D Checks whether the keypress from the event is an I
#E Because move is defined in the player class, you call it on the other player to move the shape up
#F For the canvas, any keypress event will call the handle_key function


################
## LISTING 38.4
################
class Player(object):
    def __init__(self, canvas, color):
        size = random.randint(1,100)
        x1 = random.randint(100,700)
        y1 = random.randint(100,700)
        x2 = x1+size
        y2 = y1+size
        self.color = color
        self.coords = [x1, y1, x2, y2]
        self.piece = canvas.create_rectangle(self.coords, tags=color)
        canvas.itemconfig(self.piece, fill=color)

    def move(self, direction):                           #A
        if direction == 'u':                             #B
            self.coords[1] -= 10                         #C
            self.coords[3] -= 10                         #C
            canvas.coords(self.piece, self.coords)       #D
        if direction == 'd':
            self.coords[1] += 10
            self.coords[3] += 10
            canvas.coords(self.piece, self.coords)
        if direction == 'l':
            self.coords[0] -= 10
            self.coords[2] -= 10
            canvas.coords(self.piece, self.coords)
        if direction == 'r':
            self.coords[0] += 10
            self.coords[2] += 10
            canvas.coords(self.piece, self.coords)
#A Method to move the shape, takes in a direction: one of u, d, l, r
#B Does something different for each of the four possible inputs (u, d, l, r) 
#C If youre moving up, changes the y1 and y2 values by decreasing them by indexing into the list coords
#D Changes the coordinates of the rectangle, denoted by self.piece, to the new coordinates


################
## LISTING 38.5
################
def handle_key(event):
    yellow_xy = canvas.bbox(1)                                          #A
    overlapping = canvas.find_overlapping(
                   yellow_xy[0],yellow_xy[1],yellow_xy[2],yellow_xy[3]) #B
    if 2 in overlapping:                                                #C
        canvas.create_text(100,100,font=("Arial",20),text="Tag!")       #D
#A Gets coordinates around one of the shapes
#B Finds IDs of all shapes that are within the box formed by those coordinates
#C Checks whether the ID of the other shape is in the overlapping IDs
#D Adds text to the canvas
